da0ef1c1748127d1394fe341b4e6d43e7ceff5b2
[build.git] / lbuild-initvm.sh
1 #!/bin/bash
2 # -*-shell-*-
3
4 # close stdin, as with ubuntu and debian VMs this script tends to hang and wait for input ..
5 0<&-
6
7 #shopt -s huponexit
8
9 COMMAND=$(basename $0)
10 DIRNAME=$(dirname $0)
11 BUILD_DIR=$(pwd)
12
13 # pkgs parsing utilities + lbuild-bridge.sh
14 export PATH=$(dirname $0):$PATH
15
16 # old guests have e.g. mount in /bin but this is no longer part of
17 # the standard PATH in recent hosts after usrmove, so let's keep it simple
18 export PATH=$PATH:/bin:/sbin
19
20 . build.common
21
22 # xxx fixme : we pass $lxc around in functions,
23 # but in fact then we use lxc_root which is a global..
24 # it works, but this really is poor practice
25 # we should have an lxc_root function instead
26 function lxcroot () {
27     local lxc=$1; shift
28     echo /vservers/$lxc
29 }
30
31 # XXX fixme : when creating a 32bits VM we need to call linux32 as appropriate...s
32
33 DEFAULT_FCDISTRO=f29
34 DEFAULT_PLDISTRO=lxc
35 DEFAULT_PERSONALITY=linux64
36 DEFAULT_MEMORY=3072
37
38 ##########
39 # constant
40 PUBLIC_BRIDGE=br0
41
42 # the network interface name as seen from the container
43 VIF_GUEST=eth0
44
45 ##########
46 FEDORA_MIRROR="http://mirror.onelab.eu/"
47 FEDORA_MIRROR_KEYS="http://mirror.onelab.eu/keys/"
48 FEDORA_PREINSTALLED="dnf dnf-yum passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
49 DEBIAN_PREINSTALLED="openssh-server openssh-client"
50
51 ########## networking utilities
52 function gethostbyname () {
53     local hostname=$1
54     python -c "import socket; print socket.gethostbyname('"$hostname"')" 2> /dev/null
55 }
56
57 # e.g. 21 -> 255.255.248.0
58 function masklen_to_netmask () {
59     local masklen=$1; shift
60     python <<EOF
61 import sys
62 masklen=$masklen
63 if not (masklen>=1 and masklen<=32):
64   print "Wrong masklen",masklen
65   exit(1)
66 result=[]
67 for i in range(4):
68     if masklen>=8:
69        result.append(8)
70        masklen-=8
71     else:
72        result.append(masklen)
73        masklen=0
74 print ".".join([ str(256-2**(8-i)) for i in result ])
75
76 EOF
77 }
78
79 ##############################
80 # return dnf or debootstrap
81 function package_method () {
82     local fcdistro=$1; shift
83     case $fcdistro in
84         f[0-9]*|centos[0-9]*|sl[0-9]*)
85             echo dnf ;;
86         wheezy|jessie|precise|trusty|utopic|vivid|wily|xenial)
87             echo debootstrap ;;
88         *)
89             echo Unknown distro $fcdistro ;;
90     esac
91 }
92
93 # return arch from debian distro and personality
94 function canonical_arch () {
95     local personality=$1; shift
96     local fcdistro=$1; shift
97     case $(package_method $fcdistro) in
98         dnf)
99             case $personality in
100                 *32) echo i386 ;;
101                 *64) echo x86_64 ;;
102                 *) echo Unknown-arch-1 ;;
103             esac ;;
104         debootstrap)
105             case $personality in
106                 *32) echo i386 ;;
107                 *64) echo amd64 ;;
108                 *) echo Unknown-arch-2 ;;
109             esac ;;
110         *)
111             echo Unknown-arch-3 ;;
112     esac
113 }
114
115 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
116 function almost_empty () {
117     local dir="$1"; shift ;
118     # non existing is fine
119     [ ! -d $dir ] && return 0;
120     # need to have at most one file
121     local count=$(cd $dir; ls | wc -l)
122     [ $count -le 1 ]
123 }
124
125 ##############################
126 function fedora_install() {
127     set -x
128     set -e
129
130     local lxc=$1; shift
131     local lxc_root=$(lxcroot $lxc)
132
133     local cache=/var/cache/lxc/fedora/$arch/${fedora_release}
134     mkdir -p $cache
135
136     (
137         flock --exclusive --timeout 60 200 || { echo "Cache repository is busy." ; return 1 ; }
138
139         if [ ! -e "$cache/rootfs" ]; then
140             echo "Getting cache download in $cache/rootfs ... "
141             fedora_download $cache || { echo "Failed to download 'fedora base'"; return 1; }
142         else
143             echo "Updating cache $cache/rootfs ..."
144             if ! dnf --installroot $cache/rootfs --releasever ${fedora_release} -y --nogpgcheck update ; then
145                 echo "Failed to update 'fedora base', continuing with last known good cache"
146             else
147                 echo "Update finished"
148             fi
149         fi
150
151         echo "Filling $lxc_root from $cache/rootfs ... "
152         rsync -a $cache/rootfs/ $lxc_root/
153
154         return 0
155
156         ) 200> $cache/lock
157
158     return $?
159 }
160
161 function fedora_download() {
162     set -x
163
164     local cache=$1; shift
165
166     # check the mini fedora was not already downloaded
167     INSTALL_ROOT=$cache/partial
168     echo $INSTALL_ROOT
169
170     # download a mini fedora into a cache
171     echo "Downloading fedora minimal ..."
172
173     mkdir -p $INSTALL_ROOT || { echo "Failed to create '$INSTALL_ROOT' directory" ; return 1; }
174
175     mkdir -p $INSTALL_ROOT/etc/yum.repos.d
176     mkdir -p $INSTALL_ROOT/dev
177     mknod -m 0444 $INSTALL_ROOT/dev/random c 1 8
178     mknod -m 0444 $INSTALL_ROOT/dev/urandom c 1 9
179
180     # copy yum config and repo files
181     cp /etc/yum.conf $INSTALL_ROOT/etc/
182     cp /etc/yum.repos.d/fedora{,-updates}.repo $INSTALL_ROOT/etc/yum.repos.d/
183
184     # append fedora repo files with desired ${fedora_release} and $basearch
185     for f in $INSTALL_ROOT/etc/yum.repos.d/* ; do
186       sed -i "s/\$basearch/$arch/g; s/\$releasever/${fedora_release}/g;" $f
187     done
188
189     MIRROR_URL=$FEDORA_MIRROR/fedora/releases/${fedora_release}/Everything/$arch/os
190     # since fedora18 the rpms are scattered by first name
191     # first try the second version of fedora-release first
192     RELEASE_URLS=""
193     local subindex
194     for subindex in 3 2 1; do
195         RELEASE_URLS="$RELEASE_URLS $MIRROR_URL/Packages/f/fedora-release-${fedora_release}-${subindex}.noarch.rpm"
196     done
197
198     RELEASE_TARGET=$INSTALL_ROOT/fedora-release-${fedora_release}.noarch.rpm
199     local found=""
200     local attempt
201     for attempt in $RELEASE_URLS; do
202         if curl --silent --fail $attempt -o $RELEASE_TARGET; then
203             echo "Successfully Retrieved $attempt"
204             found=true
205             break
206         else
207             echo "Failed (not to worry about) with attempt $attempt"
208         fi
209     done
210     [ -n "$found" ] || { echo "Could not retrieve fedora-release rpm - exiting" ; exit 1; }
211
212     mkdir -p $INSTALL_ROOT/var/lib/rpm
213     rpm --root $INSTALL_ROOT  --initdb
214     # when installing f12 this apparently is already present, so ignore result
215     rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-${fedora_release}.noarch.rpm || :
216     # however f12 root images won't get created on a f18 host
217     # (the issue here is the same as the one we ran into when dealing with a vs-box)
218     # in a nutshell, in f12 the glibc-common and filesystem rpms have an apparent conflict
219     # >>> file /usr/lib/locale from install of glibc-common-2.11.2-3.x86_64 conflicts
220     #          with file from package filesystem-2.4.30-2.fc12.x86_64
221     # in fact this was - of course - allowed by f12's rpm but later on a fix was made
222     #   http://rpm.org/gitweb?p=rpm.git;a=commitdiff;h=cf1095648194104a81a58abead05974a5bfa3b9a
223     # So ideally if we want to be able to build f12 images from f18 we need an rpm that has
224     # this patch undone, like we have in place on our f14 boxes (our f14 boxes need a f18-like rpm)
225
226     DNF="dnf --installroot=$INSTALL_ROOT --releasever=${fedora_release} --nogpgcheck -y"
227     echo "$DNF install $FEDORA_PREINSTALLED"
228     $DNF install $FEDORA_PREINSTALLED || { echo "Failed to download rootfs, aborting." ; return 1; }
229
230     mv "$INSTALL_ROOT" "$cache/rootfs"
231     echo "Download complete."
232
233     return 0
234 }
235
236 ##############################
237 function fedora_configure() {
238
239     set -x
240     set -e
241
242     local lxc=$1; shift
243     local fcdistro=$1; shift
244     local lxc_root=$(lxcroot $lxc)
245
246     # disable selinux in fedora
247     mkdir -p $lxc_root/selinux
248     echo 0 > $lxc_root/selinux/enforce
249
250     # enable networking and set hostname
251     cat <<EOF > ${lxc_root}/etc/sysconfig/network
252 NETWORKING=yes
253 EOF
254     cat <<EOF > ${lxc_root}/etc/hostname
255 $GUEST_HOSTNAME
256 EOF
257
258     local dev_path="${lxc_root}/dev"
259     rm -rf $dev_path
260     mkdir -p $dev_path
261     mknod -m 666 ${dev_path}/null c 1 3
262     mknod -m 666 ${dev_path}/zero c 1 5
263     mknod -m 666 ${dev_path}/random c 1 8
264     mknod -m 666 ${dev_path}/urandom c 1 9
265     mkdir -m 755 ${dev_path}/pts
266     mkdir -m 1777 ${dev_path}/shm
267     mknod -m 666 ${dev_path}/tty c 5 0
268     mknod -m 666 ${dev_path}/tty0 c 4 0
269     mknod -m 666 ${dev_path}/tty1 c 4 1
270     mknod -m 666 ${dev_path}/tty2 c 4 2
271     mknod -m 666 ${dev_path}/tty3 c 4 3
272     mknod -m 666 ${dev_path}/tty4 c 4 4
273     mknod -m 600 ${dev_path}/console c 5 1
274     mknod -m 666 ${dev_path}/full c 1 7
275     mknod -m 600 ${dev_path}/initctl p
276     mknod -m 666 ${dev_path}/ptmx c 5 2
277
278     fedora_configure_systemd $lxc
279
280     local guest_ifcfg=${lxc_root}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
281     mkdir -p $(dirname ${guest_ifcfg})
282     # starting with f29, we go for NetworkManager as older network-scripts
283     # is about to be deprecated
284     local nm_controlled=false
285     [[ $fcdistro == f29 ]] && nm_controlled=true
286     [[ $fcdistro == f3[0-9] ]] && nm_controlled=true
287
288     if [ -n "$NAT_MODE" ]; then
289         write_guest_ifcfg_natip $nm_controlled
290     else
291         write_guest_ifcfg_publicip $nm_controlled
292     fi > $guest_ifcfg
293
294     [ -z "$IMAGE" ] && fedora_configure_yum $lxc $fcdistro $pldistro
295
296     return 0
297 }
298
299 # this code of course is for guests that do run on systemd
300 function fedora_configure_systemd() {
301     set -e
302     set -x
303     local lxc=$1; shift
304     local lxc_root=$(lxcroot $lxc)
305
306     # so ignore if we can't find /etc/systemd at all
307     [ -d ${lxc_root}/etc/systemd ] || return 0
308     # otherwise let's proceed
309     ln -sf /lib/systemd/system/multi-user.target ${lxc_root}/etc/systemd/system/default.target
310     touch ${lxc_root}/etc/fstab
311     ln -sf /dev/null ${lxc_root}/etc/systemd/system/udev.service
312 # Thierry - Feb 2013 relying on getty is looking for trouble
313 # so, turning getty off for now instead
314 #    sed -i 's/After=dev-%i.device/After=/' ${lxc_root}/lib/systemd/system/getty\@.service
315     ln -sf /dev/null ${lxc_root}/etc/systemd/system/"getty@.service"
316     rm -f ${lxc_root}/etc/systemd/system/getty.target.wants/*service || :
317 # can't seem to handle this one with systemctl
318     chroot ${lxc_root} $personality chkconfig network on
319 }
320
321 # overwrite container yum config
322 function fedora_configure_yum () {
323     set -x
324     set -e
325     trap failure ERR INT
326
327     local lxc=$1; shift
328     local fcdistro=$1; shift
329     local pldistro=$1; shift
330
331     local lxc_root=$(lxcroot $lxc)
332     # rpm --rebuilddb
333     chroot ${lxc_root} $personality rpm --rebuilddb
334
335     echo "Initializing yum.repos.d in $lxc"
336     rm -f $lxc_root/etc/yum.repos.d/*
337
338     # use mirroring/ stuff instead of a hard-wired config
339     local repofile=$lxc_root/etc/yum.repos.d/building.repo
340     yumconf_mirrors $repofile ${DIRNAME} $fcdistro \
341         "" $FEDORA_MIRROR
342     # the keys stuff requires adjustment though
343     sed -i $repofile -e s,'gpgkey=.*',"gpgkey=${FEDORA_MIRROR_KEYS}/RPM-GPG-KEY-fedora-${fedora_release}-primary,"
344
345     # import fedora key so that gpgckeck does not whine or require stdin
346     # required since fedora24
347     rpm --root $lxc_root --import $FEDORA_MIRROR_KEYS/RPM-GPG-KEY-fedora-${fedora_release}-primary
348
349     # for using this script as a general-purpose lxc creation wrapper
350     # just mention 'none' as the repo url
351     if [ -n "$REPO_URL" ] ; then
352         if [ ! -d $lxc_root/etc/yum.repos.d ] ; then
353             echo "WARNING : cannot create myplc repo"
354         else
355             # exclude kernel from fedora repos
356             yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
357             for repo in $lxc_root/etc/yum.repos.d/* ; do
358                 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude"
359             done
360             # the build repo is not signed at this stage
361             cat > $lxc_root/etc/yum.repos.d/myplc.repo <<EOF
362 [myplc]
363 name= MyPLC
364 baseurl=$REPO_URL
365 enabled=1
366 gpgcheck=0
367 EOF
368         fi
369     fi
370 }
371
372 ##############################
373 # apparently ubuntu exposes a mirrors list by country at
374 # http://mirrors.ubuntu.com/mirrors.txt
375 # need to specify the right mirror for debian variants like ubuntu and the like
376 function debian_mirror () {
377     local fcdistro=$1; shift
378     case $fcdistro in
379         wheezy|jessie)
380             echo http://ftp2.fr.debian.org/debian/ ;;
381         precise|trusty|utopic|vivid|wily|xenial)
382             echo http://www-ftp.lip6.fr/pub/linux/distributions/Ubuntu/archive/ ;;
383         *) echo unknown distro $fcdistro; exit 1;;
384     esac
385 }
386
387 function debian_install () {
388     set -e
389     set -x
390     local lxc=$1; shift
391     local lxc_root=$(lxcroot $lxc)
392     mkdir -p $lxc_root
393     local arch=$(canonical_arch $personality $fcdistro)
394     local mirror=$(debian_mirror $fcdistro)
395     debootstrap --no-check-gpg --arch $arch $fcdistro $lxc_root $mirror
396     # just like with fedora we ensure a few packages get installed as well
397     # not started yet
398     #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get update"
399     #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get -y install $DEBIAN_PREINSTALLED"
400     chroot ${lxc_root} $personality apt-get update
401     chroot ${lxc_root} $personality apt-get -y install $DEBIAN_PREINSTALLED
402     # configure hostname
403     cat <<EOF > ${lxc_root}/etc/hostname
404 $GUEST_HOSTNAME
405 EOF
406
407 }
408
409 function debian_configure () {
410     local guest_interfaces=${lxc_root}/etc/network/interfaces
411     ( [ -n "$NAT_MODE" ] && write_guest_interfaces_natip || write_guest_interfaces_publicip ) > $guest_interfaces
412 }
413
414 function write_guest_interfaces_natip () {
415     cat <<EOF
416 auto $VIF_GUEST
417 iface $VIF_GUEST inet dhcp
418 EOF
419 }
420
421 function write_guest_interfaces_publicip () {
422     cat <<EOF
423 auto $VIF_GUEST
424 iface $VIF_GUEST inet static
425 address $GUEST_IP
426 netmask $NETMASK
427 gateway $GATEWAY
428 EOF
429 }
430 ##############################
431 function setup_lxc() {
432
433     set -x
434     set -e
435     #trap failure ERR INT
436
437     local lxc=$1; shift
438     local fcdistro=$1; shift
439     local pldistro=$1; shift
440     local personality=$1; shift
441
442     local lxc_root=$(lxcroot $lxc)
443
444     # create lxc container
445
446     pkg_method=$(package_method $fcdistro)
447     case $pkg_method in
448         dnf)
449             if [ -z "$IMAGE" ]; then
450                 fedora_install $lxc ||  { echo "failed to install fedora root image"; exit 1 ; }
451                 # this appears to be safer; observed in Jan. 2016 on a f23 host and a f14 cached image
452                 # we were getting this message when attempting the first chroot dnf install
453                 # rpmdb: Program version 4.8 doesn't match environment version 5.3
454                 chroot $(lxcroot $lxc) $personality rm -rf /var/lib/rpm/__db.00{0,1,2,3,4,5,6,7,8,9}
455                 chroot $(lxcroot $lxc) $personality rpm --rebuilddb
456             fi
457             fedora_configure $lxc $fcdistro || { echo "failed to configure fedora for a container"; exit 1 ; }
458             ;;
459         debootstrap)
460             if [ -z "$IMAGE" ]; then
461                 debian_install $lxc || { echo "failed to install debian/ubuntu root image"; exit 1 ; }
462             fi
463             debian_configure || { echo "failed to configure debian/ubuntu for a container"; exit 1 ; }
464             ;;
465         *)
466             echo "$COMMAND:: unknown package_method - exiting"
467             exit 1
468             ;;
469     esac
470
471     # Enable cgroup -- xxx -- is this really useful ?
472     [ -d $lxc_root/cgroup ] || mkdir $lxc_root/cgroup
473
474     ### set up resolv.conf from host
475     # ubuntu precise and on, /etc/resolv.conf is a symlink to ../run/resolvconf/resolv.conf
476     [ -h $lxc_root/etc/resolv.conf ] && rm -f $lxc_root/etc/resolv.conf
477     cp /etc/resolv.conf $lxc_root/etc/resolv.conf
478     ### and /etc/hosts for at least localhost
479     [ -f $lxc_root/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $lxc_root/etc/hosts
480
481     # grant ssh access from host to guest
482     mkdir -p $lxc_root/root/.ssh
483     cat /root/.ssh/id_rsa.pub >> $lxc_root/root/.ssh/authorized_keys
484     chmod 700 $lxc_root/root/.ssh
485     chmod 600 $lxc_root/root/.ssh/authorized_keys
486
487     # don't keep the input xml, this can be retrieved at all times with virsh dumpxml
488     local config_xml=/tmp/$lxc.xml
489     ( [ -n "$NAT_MODE" ] && write_lxc_xml_natip $lxc || write_lxc_xml_publicip $lxc ) > $config_xml
490
491     # define lxc container for libvirt
492     virsh -c lxc:/// define $config_xml
493
494     return 0
495 }
496
497 # this part does not belong in a domain any more
498 # but goes in a network object of its own existence
499 #      <network>
500 #        <name>host-bridge</name>
501 #        <forward mode="bridge"/>
502 #        <bridge name="br0"/>
503 #      </network>
504 #
505
506 function write_lxc_xml_publicip () {
507     local lxc=$1; shift
508     local lxc_root=$(lxcroot $lxc)
509     cat <<EOF
510 <domain type='lxc'>
511   <name>$lxc</name>
512   <memory>$MEMORY</memory>
513   <os>
514     <type arch='$arch2'>exe</type>
515     <init>/sbin/init</init>
516   </os>
517   <features>
518     <acpi/>
519   </features>
520   <vcpu>1</vcpu>
521   <clock offset='utc'/>
522   <on_poweroff>destroy</on_poweroff>
523   <on_reboot>restart</on_reboot>
524   <on_crash>destroy</on_crash>
525   <devices>
526     <emulator>/usr/libexec/libvirt_lxc</emulator>
527     <filesystem type='mount'>
528       <source dir='$lxc_root'/>
529       <target dir='/'/>
530     </filesystem>
531     <interface type="bridge">
532       <source bridge="$PUBLIC_BRIDGE"/>
533       <target dev='$VIF_HOST'/>
534     </interface>
535     <console type='pty' />
536   </devices>
537 </domain>
538 EOF
539 }
540
541 # grant build guests the ability to do mknods
542 function write_lxc_xml_natip () {
543     local lxc=$1; shift
544     local lxc_root=$(lxcroot $lxc)
545     cat <<EOF
546 <domain type='lxc'>
547   <name>$lxc</name>
548   <memory>$MEMORY</memory>
549   <os>
550     <type arch='$arch2'>exe</type>
551     <init>/sbin/init</init>
552   </os>
553   <features>
554     <acpi/>
555     <capabilities policy='default'>
556       <mknod state='on'/>
557     </capabilities>
558   </features>
559   <vcpu>1</vcpu>
560   <clock offset='utc'/>
561   <on_poweroff>destroy</on_poweroff>
562   <on_reboot>restart</on_reboot>
563   <on_crash>destroy</on_crash>
564   <devices>
565     <emulator>/usr/libexec/libvirt_lxc</emulator>
566     <filesystem type='mount'>
567       <source dir='$lxc_root'/>
568       <target dir='/'/>
569     </filesystem>
570     <interface type="network">
571       <source network="default"/>
572     </interface>
573     <console type='pty' />
574   </devices>
575 </domain>
576 EOF
577 }
578
579 # this one is dhcp-based
580 function write_guest_ifcfg_natip () {
581     local nm_controlled=$1; shift
582     cat <<EOF
583 DEVICE=$VIF_GUEST
584 BOOTPROTO=dhcp
585 ONBOOT=yes
586 TYPE=Ethernet
587 MTU=1500
588 EOF
589     [ "$nm_controlled" == true ] || echo NM_CONTROLLED=no
590 }
591
592 # use fixed GUEST_IP as specified by GUEST_HOSTNAME
593 function write_guest_ifcfg_publicip () {
594     local nm_controlled=$1; shift
595     cat <<EOF
596 DEVICE=$VIF_GUEST
597 BOOTPROTO=static
598 ONBOOT=yes
599 HOSTNAME=$GUEST_HOSTNAME
600 IPADDR=$GUEST_IP
601 NETMASK=$NETMASK
602 GATEWAY=$GATEWAY
603 TYPE=Ethernet
604 MTU=1500
605 EOF
606     [ "$nm_controlled" == true ] || echo NM_CONTROLLED=no
607 }
608
609 function devel_or_test_tools () {
610
611     set -x
612     set -e
613     trap failure ERR INT
614
615     local lxc=$1; shift
616     local fcdistro=$1; shift
617     local pldistro=$1; shift
618     local personality=$1; shift
619
620     local lxc_root=$(lxcroot $lxc)
621
622     local pkg_method=$(package_method $fcdistro)
623
624     local pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $PREINSTALLED)
625
626     ### install individual packages, then groups
627     # get target arch - use uname -i here (we want either x86_64 or i386)
628
629     local lxc_arch=$(chroot ${lxc_root} $personality uname -i)
630     # on debian systems we get arch through the 'arch' command
631     [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot ${lxc_root} $personality arch)
632
633     local packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
634     local groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
635
636     case "$pkg_method" in
637         dnf)
638             # --allowerasing required starting with fedora24
639             #
640             local has_dnf=""
641             chroot ${lxc_root} $personality dnf --version && has_dnf=true
642             if [ -n "$has_dnf" ]; then
643                 echo "container has dnf - invoking with --allowerasing"
644                 local pkg_installer="dnf -y install --allowerasing"
645                 local grp_installer="dnf -y groupinstall --allowerasing"
646             else
647                 echo "container has only dnf"
648                 local pkg_installer="dnf -y install"
649                 local grp_installer="dnf -y groupinstall"
650             fi
651             [ -n "$packages" ] && chroot ${lxc_root} $personality $pkg_installer $packages
652             for group_plus in $groups; do
653                 local group=$(echo $group_plus | sed -e "s,+++, ,g")
654                 chroot ${lxc_root} $personality $grp_installer "$group"
655             done
656             # store current rpm list in /init-lxc.rpms in case we need to check the contents
657             chroot ${lxc_root} $personality rpm -aq > $lxc_root/init-lxc.rpms
658             ;;
659         debootstrap)
660             # for ubuntu
661             if grep -iq ubuntu /vservers/$lxc/etc/lsb-release 2> /dev/null; then
662                 # on ubuntu, at this point we end up with a single feed in /etc/apt/sources.list
663                 # we need at least to add the 'universe' feed for python-rpm
664                 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e s,main,universe, > sources.list.d/universe.list )
665                 # also adding a link to updates sounds about right
666                 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e 's, main,-updates main,' > sources.list.d/updates.list )
667                 # tell apt about the changes
668                 chroot /vservers/$lxc apt-get update
669             fi
670             for package in $packages ; do
671                 # container not started yet
672                 #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get install -y $package" || :
673                 chroot ${lxc_root} $personality apt-get install -y $package || :
674             done
675             ### xxx todo install groups with apt..
676             ;;
677         *)
678             echo "unknown pkg_method $pkg_method"
679             ;;
680     esac
681
682     return 0
683 }
684
685 function post_install () {
686     local lxc=$1; shift
687     local personality=$1; shift
688     local lxc_root=$(lxcroot $lxc)
689     # setup localtime from the host
690     cp /etc/localtime $lxc_root/etc/localtime
691     sshd_disable_password_auth $lxc
692     # post install hook
693     [ -n "$NAT_MODE" ] && post_install_natip $lxc $personality || post_install_myplc $lxc $personality
694     # start the VM unless specified otherwise
695     if [ -n "$START_VM" ] ; then
696         echo Starting guest $lxc
697         virsh -c lxc:/// start $lxc
698         if [ -n "$NAT_MODE" ] ; then
699             wait_for_ssh $lxc
700         else
701             wait_for_ssh $lxc $GUEST_IP
702         fi
703     fi
704 }
705
706 # just in case, let's stay on the safe side
707 function sshd_disable_password_auth () {
708     local lxc=$1; shift
709     local lxc_root=$(lxcroot $lxc)
710     sed --in-place=.password -e 's,^#\?PasswordAuthentication.*,PasswordAuthentication no,' \
711         $lxc_root/etc/ssh/sshd_config
712 }
713
714 function post_install_natip () {
715
716     set -x
717     set -e
718     trap failure ERR INT
719
720     local lxc=$1; shift
721     local personality=$1; shift
722     local lxc_root=$(lxcroot $lxc)
723
724 ### From myplc-devel-native.spec
725 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
726     cat << EOF | chroot ${lxc_root} $personality bash -x
727
728     # customize root's prompt
729     /bin/cat << PROFILE > /root/.profile
730 export PS1="[$lxc] \\w # "
731 PROFILE
732
733 EOF
734
735 }
736
737 function post_install_myplc  () {
738     set -x
739     set -e
740     trap failure ERR INT
741
742     local lxc=$1; shift
743     local personality=$1; shift
744     local lxc_root=$(lxcroot $lxc)
745
746 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
747     cat << EOF | chroot ${lxc_root} $personality bash -x
748
749     # create /etc/sysconfig/network if missing
750     [ -f /etc/sysconfig/network ] || /bin/echo NETWORKING=yes > /etc/sysconfig/network
751
752     # turn off regular crond, as plc invokes plc_crond
753     /sbin/chkconfig crond off
754
755     # customize root's prompt
756     /bin/cat << PROFILE > /root/.profile
757 export PS1="[$lxc] \\w # "
758 PROFILE
759
760 EOF
761 }
762
763 ########################################
764 # workaround for broken lxc-enter-namespace
765 # 1st version was relying on virsh net-dhcp-leases
766 # however this was too fragile, would not work for fedora14 containers
767 # WARNING: this code is duplicated in lbuild-nightly.sh
768 function guest_ipv4() {
769     local lxc=$1; shift
770
771     local mac=$(virsh -c lxc:/// domiflist $lxc | egrep 'network|bridge' | awk '{print $5;}')
772     # sanity check
773     [ -z "$mac" ] && return 0
774     arp -en | grep "$mac" | awk '{print $1;}'
775 }
776
777 function wait_for_ssh () {
778     set -x
779     set -e
780
781     local lxc=$1; shift
782
783     # if run in public_ip mode, we know the IP of the guest and it is specified here
784     [ -n "$1" ] && { guest_ip=$1; shift; }
785
786     #wait max 2 min for sshd to start
787     local success=""
788     local current_time=$(date +%s)
789     local stop_time=$(($current_time + 120))
790
791     local counter=1
792     while [ "$current_time" -lt "$stop_time" ] ; do
793          echo "$counter-th attempt to reach sshd in container $lxc ..."
794          [ -z "$guest_ip" ] && guest_ip=$(guest_ipv4 $lxc)
795          [ -n "$guest_ip" ] && ssh -o "StrictHostKeyChecking no" $guest_ip 'uname -i' && {
796                  success=true; echo "SSHD in container $lxc is UP on IP $guest_ip"; break ; } || :
797          counter=$(($counter+1))
798          sleep 10
799          current_time=$(date +%s)
800     done
801
802     # Thierry: this is fatal, let's just exit with a failure here
803     [ -z $success ] && { echo "SSHD in container $lxc could not be reached (guest_ip=$guest_ip)" ; exit 1 ; }
804     return 0
805 }
806
807 ####################
808 function failure () {
809     echo "$COMMAND : Bailing out"
810     exit 1
811 }
812
813 function usage () {
814     set +x
815     echo "Usage: $COMMAND [options] lxc-name             (aka build mode)"
816     echo "Usage: $COMMAND -n hostname [options] lxc-name (aka test mode)"
817     echo "Description:"
818     echo "    This command creates a fresh lxc instance, for building, or running a test myplc"
819     echo "In its first form, spawned VM gets a private IP bridged with virbr0 over dhcp/nat"
820     echo "With the second form, spawned VM gets a public IP bridged on public bridge br0"
821     echo ""
822     echo "Supported options"
823     echo " -n hostname - the hostname to use in container"
824     echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
825     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO - current support for fedoras debians ubuntus"
826     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
827     echo " -r repo-url - used to populate yum.repos.d - required in test mode"
828     echo " -P pkgs_file - defines a set of extra packages to install in guest"
829     echo "    by default we use devel.pkgs (build mode) or runtime.pkgs (test mode)"
830     echo " -i image - the location of the rootfs"
831     echo " -m memory - the amount of allocated memory in MB - defaults to $DEFAULT_MEMORY MB"
832     echo " -s do not start VM"
833     echo " -v be verbose"
834     exit 1
835 }
836
837 ### parse args and
838 function main () {
839
840     #set -e
841     #trap failure ERR INT
842
843     if [ "$(id -u)" != "0" ]; then
844           echo "This script should be run as 'root'"
845           exit 1
846     fi
847
848     START_VM=true
849     while getopts "n:f:d:p:r:P:i:m:sv" opt ; do
850         case $opt in
851             n) GUEST_HOSTNAME=$OPTARG;;
852             f) fcdistro=$OPTARG;;
853             d) pldistro=$OPTARG;;
854             p) personality=$OPTARG;;
855             r) REPO_URL=$OPTARG;;
856             P) PREINSTALLED=$OPTARG;;
857             i) IMAGE=$OPTARG;;
858             m) MEMORY=$OPTARG;;
859             s) START_VM= ;;
860             v) VERBOSE=true; set -x;;
861             *) usage ;;
862         esac
863     done
864
865     shift $(($OPTIND - 1))
866
867     # parse fixed arguments
868     [[ -z "$@" ]] && usage
869     local lxc=$1 ; shift
870     local lxc_root=$(lxcroot $lxc)
871
872     # rainchecks
873     almost_empty $lxc_root || \
874         { echo "container $lxc already exists in $lxc_root - exiting" ; exit 1 ; }
875     virsh -c lxc:/// domuuid $lxc >& /dev/null && \
876         { echo "container $lxc already exists in libvirt - exiting" ; exit 1 ; }
877     mkdir -p $lxc_root
878
879     # if IMAGE, copy the provided rootfs to lxc_root
880     if [ -n "$IMAGE" ] ; then
881         [ ! -d "$IMAGE" ] && \
882         { echo "$IMAGE rootfs folder does not exist - exiting" ; exit 1 ; }
883         rsync -a $IMAGE/ $lxc_root/
884     fi
885
886     # check we've exhausted the arguments
887     [[ -n "$@" ]] && usage
888
889     # NAT_MODE is true unless we specified a hostname
890     [ -n "$GUEST_HOSTNAME" ] || NAT_MODE=true
891
892     # set default values
893     [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
894     [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
895     [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
896     [ -z "$MEMORY" ] && MEMORY=$DEFAULT_MEMORY
897
898     # set memory in KB
899     MEMORY=$(($MEMORY * 1024))
900
901     # the set of preinstalled packages - depends on mode
902     if [ -z "$PREINSTALLED" ] ; then
903         if [ -n "$NAT_MODE" ] ; then
904             PREINSTALLED=devel.pkgs
905         else
906             PREINSTALLED=runtime.pkgs
907         fi
908     fi
909
910     if [ -n "$NAT_MODE" ] ; then
911         # we can now set GUEST_HOSTNAME safely
912         [ -z "$GUEST_HOSTNAME" ] && GUEST_HOSTNAME=$(echo $lxc | sed -e 's,\.,-,g')
913     else
914         # as this command can be used in other contexts, not specifying
915         # a repo is considered a warning
916         # use -r none to get rid of this warning
917         if [ "$REPO_URL" == "none" ] ; then
918             REPO_URL=""
919         elif [ -z "$REPO_URL" ] ; then
920             echo "WARNING -- setting up a yum repo is recommended"
921         fi
922     fi
923
924     ##########
925     fedora_release=$(echo $fcdistro | cut -df -f2)
926
927     if [ "$personality" == "linux32" ]; then
928         arch=i386
929         arch2=i686
930     elif [ "$personality" == "linux64" ]; then
931         arch=x86_64
932         arch2=x86_64
933     else
934         echo "Unknown personality: $personality"
935     fi
936
937     # compute networking details for the test mode
938     # (build mode relies entirely on dhcp on the private subnet)
939     if [ -z "$NAT_MODE" ] ; then
940
941         #create_bridge_if_needed $PUBLIC_BRIDGE
942         lbuild-bridge.sh $PUBLIC_BRIDGE
943
944         GUEST_IP=$(gethostbyname $GUEST_HOSTNAME)
945         # use same NETMASK as bridge interface br0
946         masklen=$(ip addr show $PUBLIC_BRIDGE | grep -v inet6 | grep inet | awk '{print $2;}' | cut -d/ -f2)
947         NETMASK=$(masklen_to_netmask $masklen)
948         GATEWAY=$(ip route show | grep default | awk '{print $3}' | head -1)
949         VIF_HOST="vif$(echo $GUEST_HOSTNAME | cut -d. -f1)"
950     fi
951
952     setup_lxc $lxc $fcdistro $pldistro $personality
953
954     # historically this command is for setting up a build or a test VM
955     # kind of patchy right now though
956     devel_or_test_tools $lxc $fcdistro $pldistro $personality
957
958     # container gets started here
959     post_install $lxc $personality
960
961     echo $COMMAND Done
962
963     exit 0
964 }
965
966 main "$@"